#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySummerPlanGiftRuleCFG.h"
std::auto_ptr<M_ActivitySummerPlanGiftRuleCFG> M_ActivitySummerPlanGiftRuleCFG::msSingleton(nullptr);

int M_ActivitySummerPlanGiftRuleCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySummerPlanGiftRuleCFGData* M_ActivitySummerPlanGiftRuleCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySummerPlanGiftRuleCFGData>& M_ActivitySummerPlanGiftRuleCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySummerPlanGiftRuleCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySummerPlanGiftRuleCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySummerPlanGiftRuleCFGData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* GiftsVaild = element->Attribute("GiftsVaild");
			std::vector<std::string> vecGiftsVaild;
			boost::split(vecGiftsVaild, GiftsVaild, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecGiftsVaild.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecGiftsVaild[i].c_str(), &temp))
				{
					data.mGiftsVaild.push_back(temp);
				}
			}
		}
		data.mName = element->Attribute("Name");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySummerPlanGiftRuleCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySummerPlanGiftRuleCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySummerPlanGiftRuleCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySummerPlanGiftRuleCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySummerPlanGiftRuleCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readVectorInt(L, "GiftsVaild", data.mGiftsVaild);
		LuaCfgHelper::readString(L, "Name", data.mName);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySummerPlanGiftRuleCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySummerPlanGiftRuleCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySummerPlanGiftRuleCFG* M_ActivitySummerPlanGiftRuleCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySummerPlanGiftRuleCFG());
	}
	return msSingleton.get();
}

void M_ActivitySummerPlanGiftRuleCFG::Release()
{
	msSingleton.reset(nullptr);
}
